/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: GenericEntity.java,v 69134dbcc5fb 2010/07/11 16:36:12 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.semantic;

import javax.annotation.Nonnull;
import java.util.Map;
import it.tidalwave.util.DefaultDisplayable;
import it.tidalwave.util.DefaultIdentifiable;
import it.tidalwave.util.Id;
import it.tidalwave.util.Key;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class GenericEntity extends EntityWithProperties<GenericEntity>
  {
    public static final Class<GenericEntity> GenericEntity = GenericEntity.class;

    public GenericEntity (final @Nonnull Object ... capabilities)
      {
        super(capabilities);
      }

    protected GenericEntity (final @Nonnull Id id, final @Nonnull Map<Key<?>, Object> map)
      {
        super(id, map);
      }

    @Override @Nonnull
    protected GenericEntity clone (final @Nonnull Map<Key<?>, Object> asMap)
      {
        return new GenericEntity(getId(), asMap);
      }

    @Nonnull
    public static GenericEntity namedEntity (final @Nonnull String displayName)
      {
        return new GenericEntity(new DefaultDisplayable(displayName, "GenericEntity"));
      }

    @Nonnull
    public static GenericEntity namedEntity (final @Nonnull Id id, final @Nonnull String displayName)
      {
        return new GenericEntity(new DefaultIdentifiable(id),
                                 new DefaultDisplayable(displayName, "GenericEntity"));
      }
  }
